﻿using Android.App;
using Android.Widget;
using Android.OS;
using Android.Support.V7.App;
using Syncfusion.Pdf;
using Syncfusion.Pdf.Graphics;
using Syncfusion.Pdf.Grid;
using Syncfusion.Drawing;
using System.IO;
using System;

namespace GettingstartedAndroid
{
    [Activity(Label = "@string/app_name", Theme = "@style/AppTheme", MainLauncher = true)]
    public class MainActivity : AppCompatActivity
    {        
        protected override void OnCreate(Bundle savedInstanceState)
        {
            base.OnCreate(savedInstanceState);

            // Set our view from the "main" layout resource
            SetContentView(Resource.Layout.activity_main);

            Button button = FindViewById<Button>(Resource.Id.MyButton);
            button.Text = "Create PDF";
            button.Click += OnButtonClicked;
        }

        async void OnButtonClicked(object sender, EventArgs e)
        {
            PdfDocument document = new PdfDocument();

            //Add a page to the document
            PdfPage page = document.Pages.Add();


            PdfGrid pdfGridParagraph3 = new PdfGrid();

            pdfGridParagraph3.Columns.Add(4);

            pdfGridParagraph3.Headers.Add(1);

            PdfGridRow pdfGridHeader = pdfGridParagraph3.Headers[0];

            pdfGridHeader.Cells[0].Value = "Top";

            pdfGridHeader.Cells[1].Value = "Middle";

            pdfGridHeader.Cells[2].Value = "Bottom";

            pdfGridHeader.Cells[3].Value = "No Alignment";


            pdfGridParagraph3.Columns[0].Width = 200;
            for (int i = 0; i < 10; i++)
            {
                var pdfGridRowParagraph3Details1 = pdfGridParagraph3.Rows.Add();

                for (int j = 0; j < pdfGridRowParagraph3Details1.Cells.Count; j++)
                {
                    string s = string.Empty;
                    for (int k = 0; k < 10 * (j + 1); k++)
                    {
                        s += "This is a test" + k.ToString();
                    }
                    pdfGridRowParagraph3Details1.Cells[j].Value = s;
                    PdfStringFormat format = new PdfStringFormat();

                    if (j == 0)
                    {

                        format.LineAlignment = PdfVerticalAlignment.Top;
                        pdfGridRowParagraph3Details1.Cells[j].StringFormat = format;
                    }
                    else if (j == 1)
                    {
                        format.LineAlignment = PdfVerticalAlignment.Middle;
                        pdfGridRowParagraph3Details1.Cells[j].StringFormat = format;
                    }
                    else if (j == 2)
                    {
                        format.LineAlignment = PdfVerticalAlignment.Bottom;
                        pdfGridRowParagraph3Details1.Cells[j].StringFormat = format;
                    }
                }
            }

            pdfGridParagraph3.Draw(page, PointF.Empty);

            //Save the document to the stream
            MemoryStream stream = new MemoryStream();
            document.Save(stream);

            //Close the document
            document.Close(true);

            //Save the stream as a file in the device and invoke it for viewing
            SaveAndroid androidSave = new SaveAndroid();
            await androidSave.SaveAndView("Output.pdf", "application/pdf", stream,this);
        }
    }
}

